/******************************************************************************
 * matrix.h
 * Federico Bareilles
 * 08/02/2003
 *
 *
 *****************************************************************************/
#ifndef __MATRIX_H
#define __MATRIX_H

struct matrix{
  int d[2];
  double **M;
};

/* make the matrix: return pointo to new matrix */
struct matrix *make_matrix(int n, int m);

/* Only for testing */
int print_matrix(struct matrix *M);

int free_matrix(struct matrix *M);

/* return pointer off copy the struct matrix A */
struct matrix *copy_matrix(struct matrix *A);

/* return pointer to product A . B */
struct matrix *prod_matrix(struct matrix *A, struct matrix *B);

/* return pointer to transpuesta of matrix A */
struct matrix *trans_matrix(struct matrix *A);

/* return pointer to mino of A(ci|cj) */
struct matrix *sub_matrix(struct matrix *A, int ci, int cj);

/* return pointer to determinant of matrix M */
double det_matrix(struct matrix *M);

/* return pointer to adjunta of M */
struct matrix *adj_matrix(struct matrix *M);

/* return pointer to inversa of M; if |M| == 0 return NULL */
struct matrix *inv_matrix(struct matrix *M);


#endif
